<?php
/* ***************************************************************************

    The Mneme Project
    http://theMnemeProject.org/  http://nonprofit-crm.org/
    Copyright (C) 2009 - 2014  Eric Chadbourne
    eric.chadbourne@gmail.org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*************************************************************************** */

@define('MnemeConst', TRUE); // to allow access to include
// maybe change this to be a random number...

// an attempt to get our include working correctly when this application is
// installed in a subdirectory
define('MAIN_DIR',dirname(__FILE__) . '/');
define('INC_DIR',MAIN_DIR . 'include/');

require_once(INC_DIR . 'common.php');

// an attempt to get links working properly when application is moved to subdirectories
// use $header_dirname in links
$header_dirname = str_replace($_SERVER["DOCUMENT_ROOT"], "", dirname(__FILE__));

?>

<!doctype html>
<html>
<head>

<?php
// fetch info from db and display on page.  we echo them out later.
// this is kind of dumb.  should change it to get the values in a single
// query... select all in array and set var by column number!
$res_admin_header_title = pg_query($dbconn, "select admin_value from admin where admin_var = 'admin_header_title'");
$admin_header_title = pg_fetch_result($res_admin_header_title, 0, 0);

$res_admin_header_meta_desc = pg_query($dbconn, "select admin_value from admin where admin_var = 'admin_header_meta_desc'");
$admin_header_meta_desc = pg_fetch_result($res_admin_header_meta_desc, 0, 0);

$res_admin_header_meta_keywords = pg_query($dbconn, "select admin_value from admin where admin_var = 'admin_header_meta_keywords'");
$admin_header_meta_keywords = pg_fetch_result($res_admin_header_meta_keywords, 0, 0);

?>

	<title><?php echo $admin_header_title; ?></title>

	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
	<meta name="author" content="the mneme project" />
	<meta name="description" content="<?php echo $admin_header_meta_desc; ?>" />
	<meta name="keywords" content="<?php echo $admin_header_meta_keywords; ?>" />
	<meta name="robots" content="index, follow, noarchive" />
	<meta name="googlebot" content="noarchive" />
	<link rel="stylesheet" type="text/css" href="<?php echo $header_dirname; ?>/style.css" />
	
	<!-- below requires the ckeditor module -->
	<script src="<?php echo $header_dirname; ?>/module/ckeditor/ckeditor.js"></script> <!--ckeditor-->
	<link rel="<?php echo $header_dirname; ?>stylesheet" type="text/css" href="/module/ckeditor/samples/sample.css"> <!--ckeditor-->

</head>

<!-- #header end -->

<body>
<div id="main_container">
	
<!-- todo:  need a new logo
	<div id="header">

    	<div class="logo"><img src="/images/logo.gif" border="0" alt="" title="" /></div>
   
    </div>
-->

<br /><br />

<?php

/* depending on permission level we will show top menu items
 * 
 * admin, admin  - the system admin account
 * exec, exec  - executive staff
 * user, user_dev - development staff
 * user, user_serv - service staff
 * volunteer, vol_dev - development volunteer
 * volunteer, vol_serv - service volunteer
 */

// this is to just clean up the php warning for this var not being set
if (empty($_SESSION['ses_user_group_2'])) {
	$_SESSION['ses_user_group_2'] = null;
}

switch ($_SESSION['ses_user_group_2']) {
    case "admin":  // should see everything
		echo '<div class="menu">';
		echo '<ul>';
		echo '<li><a href="'.$header_dirname.'/index.php">home</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/index.php">constituents</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/member_create.php">create</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/simple_page/show.php?name=help">help</a></li>';
		echo '<li><a href="'.$header_dirname.'/log_in_out.php?log_me_out=yes">logout</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/reports.php">reports</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/member_modify.php">search</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/admin.php">settings</a></li>';
		echo '</ul>';
		echo '</div>';

        break;
        
    case "exec":  // should see almost everything
		echo '<div class="menu">';
		echo '<ul>';                                                           
		echo '<li><a href="'.$header_dirname.'/index.php">home</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/index.php">constituents</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/member_create.php">create</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/simple_page/show.php?name=help">help</a></li>';
		echo '<li><a href="'.$header_dirname.'/log_in_out.php?log_me_out=yes">logout</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/reports.php">reports</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/member_modify.php">search</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/admin.php">settings</a></li>';
		echo '</ul>';
		echo '</div>';
        break;
        
    case "user_dev":  // development menu only
		echo '<div class="menu">';
		echo '<ul>';                                                           
		echo '<li><a href="'.$header_dirname.'/index.php">home</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/index.php">constituents</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/member_create.php">create</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/simple_page/show.php?name=help">help</a></li>';
		echo '<li><a href="'.$header_dirname.'/log_in_out.php?log_me_out=yes">logout</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/reports.php">reports</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/member_modify.php">search</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/admin.php">settings</a></li>';
		echo '</ul>';
		echo '</div>';
        break;
        
    case "user_serv":  // service menu only
		echo '<div class="menu">';
		echo '<ul>';                                                           
		echo '<li><a href="'.$header_dirname.'/index.php">home</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/index.php">constituents</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/member_create.php">create</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/simple_page/show.php?name=help">help</a></li>';
		echo '<li><a href="'.$header_dirname.'/log_in_out.php?log_me_out=yes">logout</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/reports.php">reports</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/member_modify.php">search</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/admin.php">settings</a></li>';
		echo '</ul>';
		echo '</div>';
        break;
        
    case "vol_dev":  // volunteer
		echo '<div class="menu">';
		echo '<ul>';                                                           
		echo '<li><a href="'.$header_dirname.'/index.php">home</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/index.php">constituents</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/member_create.php">create</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/simple_page/show.php?name=help">help</a></li>';
		echo '<li><a href="'.$header_dirname.'/log_in_out.php?log_me_out=yes">logout</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/reports.php">reports</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/member_modify.php">search</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/admin.php">settings</a></li>';
		echo '</ul>';
		echo '</div>';
        break;
        break;
        
    case "vol_serv":  // volunteer
		echo '<div class="menu">';
		echo '<ul>';                                                           
		echo '<li><a href="'.$header_dirname.'/index.php">home</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/index.php">constituents</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/member_create.php">create</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/simple_page/show.php?name=help">help</a></li>';
		echo '<li><a href="'.$header_dirname.'/log_in_out.php?log_me_out=yes">logout</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/reports.php">reports</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/constituents/member_modify.php">search</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/admin.php">settings</a></li>';
		echo '</ul>';
		echo '</div>';
        break;
        break;
        
    default: // user is here if they arent logged in or something odd happens
		echo '<div class="menu">';
		echo '<ul>';                                                           
		echo '<li><a href="'.$header_dirname.'/index.php">home</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/index.php">constituents</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/member_create.php">create</a></li>';
		echo '<li><a href="'.$header_dirname.'/module/simple_page/show.php?name=help">help</a></li>';
		//echo '<li><a href="'.$header_dirname.'/log_in_out.php?log_me_out=yes">logout</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/reports.php">reports</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/member_modify.php">search</a></li>';
		//echo '<li><a href="'.$header_dirname.'/module/constituents/admin.php">settings</a></li>';
		echo '</ul>';
		echo '</div>';
        break;
}
?>
       
<div class="center_content">
