<?php
/* ***************************************************************************

    The Mneme Project
    http://theMnemeProject.org/  http://nonprofit-crm.org/
    Copyright (C) 2009 - 2014  Eric Chadbourne
    eric.chadbourne@gmail.org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*************************************************************************** */

/*
 * here an admin can create, modify and delete user accounts
 * 
 */

include("../../header.php");

#check to make sure user is admin
if ($_SESSION['ses_user_group_1'] != 'admin') {
			// what's my directory minus the document root?
			$i_am_here = str_replace($_SERVER["DOCUMENT_ROOT"], "", (__DIR__));
			// chop off the last two directories to get error path
			$he_is_there = dirname(dirname($i_am_here));
			header("Location: $he_is_there/error.php?error= insufficient privileges");
	exit;
}

//  what are we processing?  use a switch statement to select and report output
$v_account_get=pg_escape_string(strip_tags(trim($_GET['account_get'])));

switch ($v_account_get) {
    case "create":
        // lets create a new account
        $v_first_name=pg_escape_string(trim($_POST['first_name']));
		$v_last_name=pg_escape_string(trim($_POST['last_name']));
		$v_middle_name=pg_escape_string(trim($_POST['middle_name'])); # ok if null
		$v_email=pg_escape_string(trim($_POST['email']));
		$v_password=pg_escape_string(trim($_POST['password']));
		$v_permissions=pg_escape_string(trim($_POST['permissions']));

		// is the form all filled in?  if not send them back
		if ( (empty($v_first_name)) || (empty($v_last_name)) || (empty($v_email)) || (empty($v_password)) || (empty($v_permissions)) ) {
			
			// what's my directory minus the document root?
			$i_am_here = str_replace($_SERVER["DOCUMENT_ROOT"], "", (__DIR__));
			// chop off the last two directories to get error path
			$he_is_there = dirname(dirname($i_am_here));
			header("Location: $he_is_there/error.php?error=missing form values. error 18001");
			exit;
		
		}
		
		// verify this email address does not already exist
		$query_new_user_email_check = "select user_id from users where email = '$v_email'";
		$query_new_user_email_check_1 = pg_query($dbconn, $query_new_user_email_check) or die('Query failed: ' . pg_last_error());
		/*$query_new_user_email_check_2 = pg_fetch_result($query_new_user_email_check_1, 0, 0);
		
		if (!empty($query_new_user_email_check_2)) {
			
			// what's my directory minus the document root?
			$i_am_here = str_replace($_SERVER["DOCUMENT_ROOT"], "", (__DIR__));
			// chop off the last two directories to get error path
			$he_is_there = dirname(dirname($i_am_here));
			header("Location: $he_is_there/error.php?error=email already exists in database. error 22635");
			exit;  */
		$rows_name = pg_num_rows($query_new_user_email_check_1);

		if ($rows_name != 0) {
			# send to error page
			// what's my directory minus the document root?
			$i_am_here = str_replace($_SERVER["DOCUMENT_ROOT"], "", (__DIR__));
			// chop off the last two directories to get error path
			$he_is_there = dirname(dirname($i_am_here));
			header("Location: $he_is_there/error.php?error=email already exists in database. error 22635");
			exit;

		} else {  // process the request
		
			// first we figure out what permissions they want to give the user
			if ($v_permissions == 'admin') {
				$v_user_group_1 = 'admin';
				$v_user_group_2 = 'admin';
			}
			if ($v_permissions == 'exec') {
				$v_user_group_1 = 'exec';
				$v_user_group_2 = 'exec';
			}
			if ($v_permissions == 'user_serv') {
				$v_user_group_1 = 'user';
				$v_user_group_2 = 'user_serv';
			}
			if ($v_permissions == 'user_dev') {
				$v_user_group_1 = 'user';
				$v_user_group_2 = 'user_dev';
			}
			if ($v_permissions == 'vol_dev') {
				$v_user_group_1 = 'volunteer';
				$v_user_group_2 = 'vol_dev';
			}
			if ($v_permissions == 'vol_serv') {
				$v_user_group_1 = 'volunteer';
				$v_user_group_2 = 'vol_serv';
			}
				
		// update the database
		$query_new_user_insert = "insert into users (first_name, middle_name, last_name, user_group_1, user_group_2, email, password) values ('$v_first_name', '$v_middle_name', '$v_last_name', '$v_user_group_1', '$v_user_group_2', '$v_email', crypt('$v_password',gen_salt('bf')));";

		if (pg_query($dbconn, $query_new_user_insert)) {
			
			$process_results = "You have successfully added $v_email as a new user.";
			
			} else {
				
			$process_results = "The query appears to have failed.  Please note the time and how to reproduce the 
			error and contact your systems administrator.";
			
			}
		
		} // end or processing create request
        
        break;
        
    case "modify":  //todo:  add this functionality one of these days
        // do something useful here
        break;
        
    case "delete":  //delete the user
    
		$v_delete_user = pg_escape_string(trim($_POST['delete_user']));
		
		//$process_results=pg_escape_string(trim($_POST['delete_user']));
		
		$del_query="delete from users ";
		$del_query.="where user_id = '$v_delete_user'";
			
		$del_query_results = pg_query($dbconn, $del_query) or die('Query failed: ' . pg_last_error());
		
		$process_results="Success.  You have deleted user_id $v_delete_user.";

        break;
        
	default:  // they should not be on this page
			// what's my directory minus the document root?
			$i_am_here = str_replace($_SERVER["DOCUMENT_ROOT"], "", (__DIR__));
			// chop off the last two directories to get error path
			$he_is_there = dirname(dirname($i_am_here));
			header("Location: $he_is_there/error.php?error=case statement default error 26923");
		exit;
}

?>

<div class="features">

<h2>Process Account</h2>

<?php echo $process_results; ?>

</div> <!-- close of class features -->

<?php include("../../footer.php");?>
