<?php
/* ***************************************************************************

    A Constituent management module for the mneme project.
    Copyright (C) 2012 AACA
    support@aaca-boston.org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*************************************************************************** */

/*
 * the purpose of this report is to display intersection of groups.
 * it is useful to see how groups overlap.
 * 
 * group_list_annual_appeal_email
 * group_list_annual_appeal_mail
 * group_list_chinese_ny_party
 * group_list_forum
 * group_list_gala_email
 * group_list_gala_mail
 * group_list_graduation
 * group_list_newsletter 
 * 
 */

# so we have access to module specific inlcude and proper user permissions
require("../include_mod.php");

$today = date("Ymd");

// tell the browser what we're about to do
header("Content-type: application/csv");
header("Content-Disposition: attachment; filename=$today.intersection.csv");
header("Pragma: no-cache");
header("Expires: 0");

/* $my_array = select_groups("group");
* foreach ($my_array as $v_element) {
* echo "$v_element['column_name'].<br />";
* }
*/

// build an array of groups for our sql statement

$column_array = array(); // used to keep track of the columns we select
$column_array_results = array(); // used to keep track of the counts from query

$my_array = select_groups("group_list"); // call to function select_group in include_mod.php
foreach ($my_array as $v_element) {
	array_push($column_array, $v_element['column_name']);
	}

$my_array2 = select_groups("group");
foreach ($my_array2 as $v_element) {
	array_push($column_array, $v_element['column_name']);
	}

//print_r ($column_array);

 foreach($column_array as $val) {
    //print $val;
    $select_column_array_val = "select count(*) from constituents_members ";
    $select_column_array_val .= "where group_list_annual_appeal_email = 'x' ";
    $select_column_array_val .= "and (donotemail is null or donotemail = '' or donotemail = ' ') ";
    $select_column_array_val .= "and ((email != '' and email != ' ' and email is not null) ";
    $select_column_array_val .= "or (alt_email != '' and alt_email != ' ' and alt_email is not null)) ";
    $select_column_array_val .= "and (is_deceased is null or is_deceased = '' or is_deceased = ' ' or is_deceased = 'n') ";
    $select_column_array_val .= "and $val = 'x' ";
    
    $qry_get_count_results = pg_query($dbconn, $select_column_array_val) or die('Query failed: ' . pg_last_error());
	$qry_get_count_results_1 = pg_fetch_result($qry_get_count_results,0,0);
	//array_push($column_array_results, $qry_get_count_results_1);
	$column_array_results[$val] = $qry_get_count_results_1;
}

//print_r ($select_column_array_val);
//print_r ($column_array_results);

echo "Below is the intersection between group_list_annual_appeal_email and all other groups.";
echo "\n";
echo "Note that if donotemail is checked OR there is no email address OR is_deceased is checked, they will be excluded from this report.";
echo "\n";


foreach($column_array_results as $key => $value) {
  echo "$key = $value";
  echo "\n";
}

?>
